using Documenter
using dg1d

makedocs(;
         sitename="dg1d.jl",
         pages = [
             "index.md",
             "dg.md",
             "setup.md",
             "parameters.md",
             "Projects" => [
                "projects/HeatEq.md",
                "projects/AdvectionEq.md",
                "projects/AV.md",
                "projects/TOV.md",
                "projects/GRHD.md",
             ],
             "Design" => [
                "design/styleguide.md"
                "design/parameters.md"
            ],
         ],
        format = Documenter.HTML(
                    prettyurls = !("local" in ARGS)
                   ),
        repo = "https://git.tpi.uni-jena.de/dg/dg1d.jl"
       )
