function make_BoundaryConditions(env, eq, rsolver, prms)

  @unpack bc = prms

  lhs_bc, rhs_bc = if bc == "periodic"
    PeriodicBC(), PeriodicBC()
  elseif bc == "from_id"
    @unpack rho, q, E = get_dynamic_variables(env.cache)
    lhs_state = (rho[1], q[1], E[1])
    rhs_state = (rho[end], q[end], E[end])
    (DirichletBC(lhs_state), DirichletBC(rhs_state))
  else
    error("Unknown boundary condition requested: '$bc'")
  end

  return BoundaryConditions(lhs_bc, rhs_bc, rsolver)
end


function make_BoundaryConditions_LDG(env, eq, ldg_rsolver, prms)

  @unpack bc = prms

  isnothing(ldg_rsolver) && return nothing

  lhs_bc, rhs_bc = if type == "periodic"
    PeriodicBC(), PeriodicBC()
  elseif bc == "from_id"
    OutflowBC(), OutflowBC()
  else
    error("Unknown boundary condition requested: '$bc'")
  end

  return BoundaryConditions(lhs_bc, rhs_bc, ldg_rsolver)
end
