struct EulerEquation{T_EoS<:EquationOfState.AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
end

struct EulerEquation2d{T_EoS<:EquationOfState.AbstractEquationOfState} <: AbstractEquation
  eos::T_EoS
end


mutable struct Project{T_Equation <:EulerEquation,
                       T_RSolver  <:Maybe{AbstractRiemannSolver},
                       T_HRSC     <:Maybe{HRSC.AbstractHRSC},
                       T_TCI      <:Maybe{TCI.AbstractTCI},
                       T_LDG_RSolver<:Maybe{AbstractRiemannSolver},
                       T_AV_RSolver<:Maybe{AbstractRiemannSolver},
                       T_BC}

  equation::T_Equation
  rsolver::T_RSolver
  hrsc::T_HRSC
  tci::T_TCI
  ldg_rsolver::T_LDG_RSolver
  av_rsolver::T_AV_RSolver
  bdrycond::T_BC
end

mutable struct Project2d{T_Equation <:EulerEquation2d,
                         T_RSolver1  <:Maybe{AbstractRiemannSolver},
                         T_RSolver2  <:Maybe{AbstractRiemannSolver},
                         T_RSolver3  <:Maybe{AbstractRiemannSolver},
                         T_RSolver4  <:Maybe{AbstractRiemannSolver},
                         T_HRSC     <:Maybe{HRSC.AbstractHRSC},
                         T_TCI      <:Maybe{TCI.AbstractTCI},
                         T_LDG_RSolver<:Maybe{AbstractRiemannSolver},
                         T_AV_RSolver<:Maybe{AbstractRiemannSolver}}

  equation::T_Equation
  rsolver_rho::T_RSolver1
  rsolver_qx::T_RSolver2
  rsolver_qy::T_RSolver3
  rsolver_E::T_RSolver4
  hrsc::T_HRSC
  tci::T_TCI
  ldg_rsolver::T_LDG_RSolver
  av_rsolver::T_AV_RSolver
end
