#######################################################################
#                               Factory                               #
#######################################################################


function make_Equation(prms, dims)
  if dims == 1
    return HeatEquation()
  elseif dims == 2
    TODO()
  end
  error("Unknown equation requested: '$equation'")
end


#######################################################################
#                          AbstractHeatEq                           #
#######################################################################


@with_signature [legacy=false] function nflux(eq::HeatEquation)
  @accepts        q, v
  @accepts [bdry] bdry_q, bdry_v
  @accepts [bdry] nx
  nflx      = -nx*q
  bdry_nflx = -nx*bdry_q
  nflx_u    = 0.5 * (nflx + bdry_nflx) # mean flux
  # nflx_u    = LLF(nflx, bdry_nflx, q, bdry_q, 1.0)
  @returns [bdry] nflx_u
end
@with_signature [legacy=false] function bdry_nflux(eq::HeatEquation)
  @accepts        flx_u, u, v
  @accepts        init_u, init_v
  @accepts [bdry] nx

  TODO()
  bdry_u    = -u + 2*init_u
  nflx      = nx*flx_u
  bdry_nflx = nx*bdry_flx_u
  vmax      = absmax(v, bdry_v)
  nflx_u    = 0.5 * (nflx + bdry_nflx)
  @returns [bdry] nflx_u
end


@with_signature [legacy=false] function flux(eq::HeatEquation)
  @accepts u, q
  flx_u = -q
  @returns flx_u
end
@with_signature [legacy=false] function maxspeed(eq::HeatEquation)
  @accepts u
  # TODO What is the speed in a heat equation?
  v = 1
  @returns v
end


#######################################################################
#                                 LDG                                 #
#######################################################################


@with_signature [legacy=false] function ldg_flux(eq::HeatEquation)
  @accepts u
  flx_q = -u
  @returns flx_q
end
@with_signature [legacy=false] function ldg_nflux(eq::HeatEquation)
  @accepts        u
  @accepts [bdry] bdry_u
  @accepts [bdry] nx
  nflx      = -nx*u
  bdry_nflx = -nx*bdry_u
  nflx_q    = 0.5 * (nflx + bdry_nflx)
  @returns [bdry] nflx_q
end
