function make_BoundaryConditions(env, equation, rsolver, prms)
  @unpack bc = prms

  lhs_bc, rhs_bc = if bc == "periodic"
    PeriodicBC(), PeriodicBC()
  elseif bc == "no_inflow"
    DirichletBC((0.0,)), OutflowBC()
  elseif bc == "from_id"
    @unpack u = get_dynamic_variables
    u_lhs, u_rhs = deepcopy(u[1]), deepcopy(u[end])
    lhs_bdry = t -> (u_lhs,)
    rhs_bdry = t -> (u_rhs,)
    DirichletBC(lhs_bdry), DirichletBC(rhs_bdry)
  else
    error("Unknown boundary condition requested: '$bc'")
  end

  return BoundaryConditions(lhs_bc, rhs_bc, rsolver)
end


function make_BoundaryConditions_LDG(env, equation, ldg_rsolver, prms)

  @unpack bc = prms

  isnothing(ldg_rsolver) && return nothing

  lhs_bc, rhs_bc = if bc == "periodic"
    PeriodicBC(), PeriodicBC()
  elseif bc == "no_inflow"
    OutflowBC(), OutflowBC()
  elseif bc == "from_id"
    OutflowBC(), OutflowBC()
  else
    error("Unknown boundary condition requested: '$bc'")
  end

  return BoundaryConditions(lhs_bc, rhs_bc, ldg_rsolver)
end
