export ObjectCache


struct ObjectCache{T_Key,T_Object,T_Blueprint}
  cache::Dict{T_Key,T_Object}
  blueprint::T_Blueprint

  function ObjectCache{T_Key,T_Object}(blueprint::T_Blueprint) where {T_Key,T_Object,T_Blueprint}
    @assert length(methods(blueprint, [T_Key])) > 0 """
      `blueprint` must accept argument `key::$T_Key`
    """
    return new{T_Key,T_Object,T_Blueprint}(Dict{T_Key,T_Object}(), blueprint)
  end
end


function Base.getindex(c::ObjectCache{T_Key,T_Object,T_Blueprint}, key::T_Key) where {T_Key,T_Object,T_Blueprint}
  obj = get(c.cache, key, nothing)
  !isnothing(obj) && return obj
  obj = c.blueprint(key)::T_Object
  c.cache[key] = obj
  return obj
end


Base.sizehint!(obj::ObjectCache, n) = sizehint!(obj.cache)
